﻿//
//  ICPanel.as
//  InfiniteCanvas (Flash Viewer)
//
//  Created by Markus Mueller <markus@mindnode.com>.
//  http://www.infinitecanvas.com/
//  Copyright (c) 2003-2005 Markus Mueller. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//  
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//  
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//  


class ICMovieClip extends MovieClip {	
	private var _canvasX:Number = 0; 
	private var _canvasY:Number = 0;
	private var _canvasWidth:Number = 0;
	private var _canvasHeight:Number = 0;
	private var _canvasRotation:Number = 0;
	private var _canvasTransparency:Number = 100;
	private var _container:MovieClip = null;

	
	function initPanel() {
		this._x = _canvasX - _canvasWidth / 2;
		this._y = _canvasY - _canvasHeight / 2;
		_container._width = _canvasWidth;
		_container._height = _canvasHeight;
		
		if (_canvasRotation != 0) {
			var origin:Object = this.getOrigin();
			_rotation = -_canvasRotation;
			var tmpOrigin:Object = getOrigin();
			
			this._x += origin.x - tmpOrigin.x;
			this._y += origin.y - tmpOrigin.y;
		}

		_container._width = _canvasWidth;
		_container._height = _canvasHeight;
		_container._alpha = _canvasTransparency;
	}
	
	private function getOrigin() : Object{
		var bounds:Object = this.getBounds(this._parent);
		return {x:(bounds.xMin+bounds.xMax)/2, y:(bounds.yMin+bounds.yMax)/2};
	}
		
	function initTrail() {
		_x = _canvasX;
		_y = _canvasY;
	}
	
	function setCanvasX(canvasX:Number) {
		_canvasX = canvasX;
	}
	
	function getCanvasX() : Number {
		return _canvasX;
	}
	
	function setCanvasY(canvasY:Number) {
		_canvasY = canvasY;
	}
	
	function getCanvasY() : Number {
		return _canvasY;
	}
	
	function setCanvasWidth(canvasWidth:Number) {
		_canvasWidth = canvasWidth;
	}
	
	function getCanvasWidth() : Number {
		return _canvasWidth;
	}
	
	function setCanvasHeight(canvasHeight:Number) {
		_canvasHeight = canvasHeight;
	}
	
	function getCanvasHeight() : Number {
		return _canvasHeight;
	}
	
	function setCanvasRotation(canvasRotation:Number) {
		_canvasRotation = canvasRotation;
	}
	
	function getCanvasRotation() : Number {
		return _canvasRotation;
	}	
	
	function setCanvasTransparency(canvasTransparency:Number) {
		_canvasTransparency = canvasTransparency;
		if (_canvasTransparency  == undefined) {
			_canvasTransparency = 100;
		}
	}
	
	function getCanvasTransparency() : Number {
		return _canvasTransparency;
	}
	
	public function setContainer(container:MovieClip) {
		_container = container;
	
	}
}